#!/usr/local/bin/python
#
#	A simple disassembler for python codes.

rcs_ident = '$Header: /var/home/siebren/src/xfreeze/RCS/da.py,v 1.3 1995/10/15 19:04:04 siebren Exp $'


import getopt, marshal, sys, types
from sys import argv, exit, stderr
from os import path
basename = path.basename

import decode
from magic import magics


def die(fmt, *args):
	stderr.write(fmt % args)
	if fmt[-1:] <> '\n': stderr.write('\n')
	exit(1)


def main():
	try:
		fast = 0
		options, args = getopt.getopt(argv[1:], 'f')
		if not args: raise getopt.error, 'missing file arguments'
		for o,a in options:
			if o == '-f':
				fast = 1
			else:
				raise getopt.error, 'Unanticipated option ' + repr(o)
	except getopt.error, err:
		if type(err) <> type(''): err = ''	# Suppress error
		elif err[-1] <> '\n': err = err + '\n'	# Append missing newline
		stderr.write(basename(argv[0]) + ': ' + err)
		die('Usage: %s [-f] file...\nDisassemble a .pyc or .pyo file', basename(argv[0]))

	for name in args:
		if not path.isfile(name):
			die('%s is not a file', name)
		if len(argv) > 2:
			print '\n' + name + ':'
		try:
			f = open(name, 'rb')
			header = f.read(8)
			if header[:4] <> magics:
				print 'Warning: wrong magic in', name
			code = marshal.load(f)
			f.close()
			if type(code) <> types.CodeType:
				raise a_serious_error	# ;-)
		except:
			if sys.exc_value:
				die('no code readable from %s: %s %s',
					`name`, sys.exc_type, `sys.exc_value`)
			else:
				die('no code readable from %s: %s',
					`name`, sys.exc_type)

		# Got a reasonable code thing if we got here
		# Catch IOError to avoid printing stacktraces
		# when the output is a broken pipe
		try:
			decode.decode(code, fast)
		except IOError:	# Write on a pipe with no-one to read it.
			exit(1)
	exit(0)


if __name__ == '__main__':
	main()
