rcs_ident = '$Header: /var/home/siebren/src/xfreeze/RCS/decode.py,v 1.4 1995/10/20 10:54:16 siebren Exp siebren $'

import marshal, strop
from types import CodeType

import ltup
from opcode import cmp_op, HAS_ARG, opcode


def decode(code, fast, indent = 0, displace = 0):
    itabs = '\t' * indent
    detail = ''
    if code.co_name <> '?':
	detail = 'for ' + code.co_name + ' '
    if code.co_filename <> '?':
    	detail = detail + 'in ' + code.co_filename + ' '
    detail = detail[:-1]	# Strip trailing space, if any

    print '\n' + itabs + 'co_names ' + detail + ':'

    #snames = map(None, code.co_names)
    #snames.sort()
    #print itabs + '\t' + strop.joinfields(snames, '\n' + itabs + '\t')

    for i in xrange(len(code.co_names)):
    	print '%s %5d: %s' % (itabs, i, code.co_names[i])

    print itabs + 'co_consts ' + detail, len(code.co_consts), '(%d bytes to marshal):' % (len(marshal.dumps(code.co_consts)),)
    print itabs + 'co_code ' + detail + ':'
    if fast:
    	blocks = [code.co_code]
    else:
	blocks = ltup.dividebb(code.co_code)
    for s in blocks:
	offset = 0
	while offset < len(s):
	    if offset == 0 and not fast:
		print itabs + '%6d:' % (offset + displace),
	    else:
		print '\t' * (indent+1),

	    op = ord(s[offset])
	    offset = offset + 1

	    if not opcode.has_key(op):
		raise ValueError, 'illegal opcode <' + `op` + '>'
	    elif not HAS_ARG(op):
		print strop.lower(opcode[op])
	    else:	# It has an argument
		recursiveCodeObject = None
		if len(s) < offset + 2:
		    raise ValueError, 'missing arg to instruction ' +`opcode[op]` + ' at ' + `displace + offset - 1`
		arg = ord(s[offset]) + ord(s[offset+1]) * 256
		offset = offset + 2

		if opcode[op] in ('COMPARE_OP',):
		    arg = cmp_op[arg]
		elif opcode[op] in ('LOAD_CONST',):
		    #arg = (arg, code.co_consts[arg])
		    arg = code.co_consts[arg]
		    if type(arg) == CodeType:	# Should filter ones I saw before?
			recursiveCodeObject = arg
		elif opcode[op] in ('STORE_FAST','LOAD_FAST', 'DELETE_FAST'):
		    arg = code.co_varnames[arg]
		elif opcode[op] in (
		    'DELETE_NAME', 'LOAD_NAME', 'STORE_NAME',
		    'IMPORT_NAME', 'IMPORT_FROM', 'LOAD_LOCAL',
		    'STORE_ATTR', 'DELETE_ATTR', 'LOAD_ATTR',
		    'STORE_GLOBAL', 'DELETE_GLOBAL', 'LOAD_GLOBAL',
		):
		    if arg < 0 or arg >= len(code.co_names):
		    	arg = '<illegal %s arg %d>' % (opcode[op], arg)
		    else:
			arg = code.co_names[arg]
		elif opcode[op] in ltup.rel_jump:
		    #arg = '%d (to %d)' % (arg, offset + displace + arg)
		    arg = offset + displace + arg

		print strop.lower(opcode[op]) + '(' + `arg` + ')'

		if recursiveCodeObject <> None:
		    decode(recursiveCodeObject, fast, indent+1, 0)
		arg = None
	    # end if
	# end while
	displace = displace + len(s)
    print itabs + '# end ' + detail

# end decode
