#
#	Python internal opcodes -- from Include/opcode.h
#
rcs_ident = '$Header: /var/home/siebren/src/freeze/RCS/opcode.py,v 1.1 1995/10/14 13:21:59 siebren Exp $'

opcode = {}

opcode[0] = "STOP_CODE"
opcode[1] = "POP_TOP"
opcode[2] = "ROT_TWO"
opcode[3] = "ROT_THREE"
opcode[4] = "DUP_TOP"

opcode[10] = "UNARY_POSITIVE"
opcode[11] = "UNARY_NEGATIVE"
opcode[12] = "UNARY_NOT"
opcode[13] = "UNARY_CONVERT"
opcode[14] = "UNARY_CALL"
opcode[15] = "UNARY_INVERT"

opcode[19] = "BINARY_POWER"
opcode[20] = "BINARY_MULTIPLY"
opcode[21] = "BINARY_DIVIDE"
opcode[22] = "BINARY_MODULO"
opcode[23] = "BINARY_ADD"
opcode[24] = "BINARY_SUBTRACT"
opcode[25] = "BINARY_SUBSCR"
opcode[26] = "BINARY_CALL"

opcode[30] = "SLICE"
# Also uses 31-33
opcode[31] = "SLICE+1"
opcode[32] = "SLICE+2"
opcode[33] = "SLICE+3"

opcode[40] = "STORE_SLICE"
# Also uses 41-43
opcode[41] = "STORE_SLICE+1"
opcode[42] = "STORE_SLICE+2"
opcode[43] = "STORE_SLICE+3"

opcode[50] = "DELETE_SLICE"
# Also uses 51-53
opcode[51] = "DELETE_SLICE+1"
opcode[52] = "DELETE_SLICE+2"
opcode[53] = "DELETE_SLICE+3"

opcode[60] = "STORE_SUBSCR"
opcode[61] = "DELETE_SUBSCR"

opcode[62] = "BINARY_LSHIFT"
opcode[63] = "BINARY_RSHIFT"
opcode[64] = "BINARY_AND"
opcode[65] = "BINARY_XOR"
opcode[66] = "BINARY_OR"


opcode[70] = "PRINT_EXPR"
opcode[71] = "PRINT_ITEM"
opcode[72] = "PRINT_NEWLINE"

opcode[80] = "BREAK_LOOP"
opcode[81] = "RAISE_EXCEPTION"
opcode[82] = "LOAD_LOCALS"
opcode[83] = "RETURN_VALUE"
opcode[84] = "LOAD_GLOBALS"
opcode[85] = "EXEC_STMT"

opcode[86] = "BUILD_FUNCTION"
opcode[87] = "POP_BLOCK"
opcode[88] = "END_FINALLY"
opcode[89] = "BUILD_CLASS"

HAVE_ARGUMENT = 90		# Opcodes from here have an argument:

opcode[90] = "STORE_NAME"	# Index in name list
opcode[91] = "DELETE_NAME"	# ""
opcode[92] = "UNPACK_TUPLE"	# Number of tuple items
opcode[93] = "UNPACK_LIST"	# Number of list items
opcode[94] = "UNPACK_ARG"	# Number of arguments
opcode[95] = "STORE_ATTR"	# Index in name list
opcode[96] = "DELETE_ATTR"	# ""
opcode[97] = "STORE_GLOBAL"	# ""
opcode[98] = "DELETE_GLOBAL"	# ""
opcode[99] = "UNPACK_VARARG"	# Minimal number of arguments

opcode[100] = "LOAD_CONST"	# Index in const list
opcode[101] = "LOAD_NAME"	# Index in name list
opcode[102] = "BUILD_TUPLE"	# Number of tuple items
opcode[103] = "BUILD_LIST"	# Number of list items
opcode[104] = "BUILD_MAP"	# Always zero for now
opcode[105] = "LOAD_ATTR"	# Index in name list
opcode[106] = "COMPARE_OP"	# Comparison operator
opcode[107] = "IMPORT_NAME"	# Index in name list
opcode[108] = "IMPORT_FROM"	# Index in name list
opcode[109] = "ACCESS_MODE"	# Name (mode is int on top of stack)

opcode[110] = "JUMP_FORWARD"	# Number of bytes to skip
opcode[111] = "JUMP_IF_FALSE"	# ""
opcode[112] = "JUMP_IF_TRUE"	# ""
opcode[113] = "JUMP_ABSOLUTE"	# Target byte offset from beginning of code
opcode[114] = "FOR_LOOP"	# Number of bytes to skip

opcode[115] = "LOAD_LOCAL"	# Index in name list
opcode[116] = "LOAD_GLOBAL"	# Index in name list

opcode[117] = "SET_FUNC_ARGS"	# Argcount

opcode[120] = "SETUP_LOOP"	# Target address (absolute)
opcode[121] = "SETUP_EXCEPT"	# ""
opcode[122] = "SETUP_FINALLY"	# ""

opcode[123] = "RESERVE_FAST"	# Number of local variables
opcode[124] = "LOAD_FAST"	# Local variable number
opcode[125] = "STORE_FAST"	# Local variable number
opcode[126] = "DELETE_FAST"	# Local variable number

opcode[127] = "SET_LINENO"	# Current line number

opcode[130] = "RAISE_VARARGS"	# Number of raise arguments (1, 2 or 4)
opcode[131] = "CALL_FUNCTION"	# #args + (#kwargs<<8)
opcode[132] = "MAKE_FUNCTION"	# #defaults
opcode[133] = "BUILD_SLICE"	# Number of items

# Comparison operator codes (argument to COMPARE_OP)
cmp_op = (
    '<',
    '<=',
    '==',
    '!=',
    '>',
    '>=',
    'in',
    'not in',
    'is',
    'is not',
    'exception match',
    'BAD'
)

def HAS_ARG(op): return op >= HAVE_ARGUMENT
